% the 4 linear systems
  A1=[0 0; 0 16]/100;
  A2=[85 4; -4 85]/100;
  A3=[20 -26; 23 22]/100;
  A4=[-15 28; 26 24]/100;
  b1=[100; 0];
  b2=[15; 36];
  b3=[80; 9];
  b4=[115; -17];

% colors
  col1=[0 0 0];
  col2=[1 0 0];
  col3=[0 1 0];
  col4=[0 0 1];

% cell arrays  
  A={A1,A2,A3,A4}; b={b1,b2,b3,b4}; col={col1,col2,col3,col4};

% equilibria
  xbar1=inv(eye(2)-A1)*b1;
  xbar2=inv(eye(2)-A2)*b2;
  xbar3=inv(eye(2)-A3)*b3;
  xbar4=inv(eye(2)-A4)*b4;

% stability analysis
  [V1,D1]=eig(A1);
  [V2,D2]=eig(A2);
  [V3,D3]=eig(A3);
  [V4,D4]=eig(A4);
  rho2=abs(D2(1,1));
  th2=angle(D2(1,1));
  rho3=abs(D3(1,1));
  th3=angle(D3(1,1));

% plot
  figure
  line(xbar1(1,1),xbar1(2,1),'linestyle','none','marker','*','color',col1);
  line(xbar2(1,1),xbar2(2,1),'linestyle','none','marker','*','color',col2);
  line(xbar3(1,1),xbar3(2,1),'linestyle','none','marker','*','color',col3);
  line(xbar4(1,1),xbar4(2,1),'linestyle','none','marker','*','color',col4);
  axis('equal'); box;
  axis([0 200 0 200]);

% initial state
  x=[100,0];
% x=randi([0,199],[1,2]);

% linear dynamics
  for k=1:4
    for t=1:999
      x(t+1,:)=(A{k}*x(t,:)'+b{k})';
    end
    line(x(:,1),x(:,2),'linestyle','none','marker','.','color',col{k});
  end

% deterministic case
% logistic=@(z) 4*z.*(1-z);
% z=rand;

% nonlinear dynamics
  for t=1:10^5-1
    dado=randi([0,99]);
  % dado = z*100;
  % for k=1:10, z = logistic(z);end
    if dado<1,
      x(t+1,:)=(A1*x(t,:)'+b1)';
    elseif dado<86,
      x(t+1,:)=(A2*x(t,:)'+b2)';
    elseif dado<93,
      x(t+1,:)=(A3*x(t,:)'+b3)';
    else,
      x(t+1,:)=(A4*x(t,:)'+b4)';
    end
  % approximation of the division by 100 in A
  %  x(t+1)=fix(x(t+1));
  end

% plot
  line(x(:,1),x(:,2),'linestyle','none','marker','.','MarkerSize',8,'color',[0 .5 0]);
